#!/usr/bin/perl

######
# POP3 webchecker v1.0
# Author: Jimmy Scott
# Nick: Sick`
# Mail: admin@inet-solutions.be
# Address:      Jimmy Scott
#               Goordijk 66
#               2930 BRASSCHAAT
#               BELGIUM
# source: http://pub.inet-solutions.be
# Updated: Fri Nov 21 10:23:15 CET 2003
###
#
# DEPENDS: Net::POP3
#
###
#
# Copyright (C) 2003 Jimmy Scott <http://www.inet-solutions.be>
#
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#   1. Redistributions of source code must retain the above copyright notice,
#      this list of conditions and the following disclaimer.
#
#   2. Redistributions in binary form must reproduce the above copyright
#      notice, this list of conditions and the following disclaimer in the
#      documentation and/or other materials provided with the distribution.
#
#   3. The names of the authors may not be used to endorse or promote products
#      derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.
#
######

print "Content-type: text/html\n\n";

use Net::POP3;
use CGI qw(param);

   $host = param('host');
   $user = param('user');
   $pass = param('pass');

if ((! defined $host) && (! defined $user) && (! defined $pass))
{
   die "Please provide host, user, pass.\n";
}

$pop = Net::POP3->new("$host", Timeout => 500);
if (! defined $pop)
{
   die "Unable to connect to $host: $!.\n";
}

if ($pop->login($user,$pass))
{
   print "<pre>\n";
   my $msglist = $pop->list;
   foreach my $msgnum (sort {$a <=> $b} keys %$msglist)
   {
      print "$msgnum: \tSize: ", int( $pop->list($msgnum) / 102.4 ) / 10, " kb\n";
      my $header = $pop->top($msgnum);
      my $from;
      my $subject;
      FROM:
      foreach ( @$header )
      {
         if ( $_ =~ /From: (.+)/ )
	 {
	    $from = $1;
	    last FROM;
	 }
      }
      print "\t- From: ", $from, "\n";
      SUBJECT:
      foreach ( @$header )
      {
         if ( $_ =~ /Subject: (.+)/ )
         {
            $subject = $1;
            last SUBJECT;
         }
      }
      print "\t- Subject: ", $subject, "\n";
      print "*****\n";
   }
   print "</pre>\n";
}
else
{
   print "Wrong user/pass.\n";
}

$pop->quit;

